;description: attributes and keywords support

(define-module (alterator lookout common)
	       :use-module (ice-9 syncase)
	       :export (declare-attribute
			 declare-keyword))

;attribute becomes a function that return it's symbol if it was called without argument (e.g. (text))
;and return a list started with attr symbol if function was calle with attribute value (e.g. (text value))
(define-macro (declare-attribute x)
	      (let ((name (gensym)))
		`(define (,x . ,name)
		   (if (null? ,name) ',x
		     `(attr ,',x ,@,name)))))

;declare symbol that refer to itself
(define-syntax declare-keyword
  (syntax-rules () ((_ x) (define x 'x))))

